/**
 * @file libertine_store/scope.h
 * @brief The internal interface for the Libertine Store scope class.
 */
/*
 * Copyright 2016 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, version 3, as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef LIBERTINE_STORE_SCOPE_H_
#define LIBERTINE_STORE_SCOPE_H_

#include <unity/scopes/ScopeBase.h>

namespace Libertine
{
namespace Store
{


class Scope
: public unity::scopes::ScopeBase
{
public:

  /**
   * Initializes the scope instance.
   */
  void
  start(std::string const&) override;

  /**
   * Called each time a new query is requested
   */
  unity::scopes::SearchQueryBase::UPtr
  search(unity::scopes::CannedQuery const&    query,
         unity::scopes::SearchMetadata const& metadata) override;

  /**
   * Gets an application preview.
   */
  unity::scopes::PreviewQueryBase::UPtr
  preview(unity::scopes::Result const&         result,
          unity::scopes::ActionMetadata const& metadata) override;
};


} // namespace Store
} // namespace Libertine

#endif /* LIBERTINE_STORE_SCOPE_H_ */



