/*
 * Copyright 2016 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, version 3, as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef SERVICE_MANAGER_H
#define SERVICE_MANAGER_H

#include "scope/store/package.h"

#include <QString>
#include <QVariant>


namespace Libertine
{
namespace Store
{


class ServiceManager
{
public:
  explicit ServiceManager();
  virtual ~ServiceManager() = default;

  virtual QList<Package> search_cache(QString const& query) const;
  virtual Package app_info(QString const& app_id) const;

private:
  bool valid() const;

  template<class T>
  T call(QString const& method, QVariant const& = QVariant()) const;
};


} // namespace Libertine
} // namespace Store


#endif // SERVICE_MANAGER_H
